-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}
M.type = "auxilliary"
M.relevantDevice = mainEngine_RR, mainEngine_RL,mainEngine_FR, mainEngine_FL;
M.throttle_RR = 0
M.throttle_FR = 0
M.throttle_FL = 0
M.throttle_RL = 0
M.brake_r = 0
M.brake_l = 0
local RL = nil
local RR = nil
local FR = nil
local FL = nil

local min = math.min
local max = math.max
local abs = math.abs

local steering_input_drive = nil

--local span = nil

local function updateGFX(dt)


  local throttle_FR = min(max(electrics.values.throttle_FR, 0), 1)
  local throttle_RR = min(max(electrics.values.throttle_RR, 0), 1)
  local throttle_FL = min(max(electrics.values.throttle_FL, 0), 1)  
  local throttle_RL = min(max(electrics.values.throttle_RL, 0), 1)  
  
if electrics.values.gear == "N" then 
	if electrics.values.steering_input > 0.05 then
		powertrain.getDevice("mainEngine_FL").motorDirection = -1
		powertrain.getDevice("mainEngine_RL").motorDirection = -1
		powertrain.getDevice("mainEngine_RR").motorDirection = 1
		powertrain.getDevice("mainEngine_FR").motorDirection = 1

				electrics.values.throttle_RR =  electrics.values.throttle
				electrics.values.throttle_FR =  electrics.values.throttle
				electrics.values.throttle_RL = electrics.values.throttle
				electrics.values.throttle_FL = electrics.values.throttle

	elseif electrics.values.steering_input < -0.05 then
		powertrain.getDevice("mainEngine_FL").motorDirection =1
		powertrain.getDevice("mainEngine_RL").motorDirection = 1
		powertrain.getDevice("mainEngine_FR").motorDirection = -1
		powertrain.getDevice("mainEngine_RR").motorDirection = -1

				electrics.values.throttle_RR =  electrics.values.throttle
				electrics.values.throttle_FR =  electrics.values.throttle
				electrics.values.throttle_RL = electrics.values.throttle
				electrics.values.throttle_FL = electrics.values.throttle

	else 
		powertrain.getDevice("mainEngine_FL").motorDirection = 0
		powertrain.getDevice("mainEngine_RL").motorDirection = 0
		powertrain.getDevice("mainEngine_FR").motorDirection = 0	
		powertrain.getDevice("mainEngine_RR").motorDirection = 0	
	end 
elseif electrics.values.gear == "S" then 
	if electrics.values.steering_input > 0.05 then
		powertrain.getDevice("mainEngine_FL").motorDirection = -1
		powertrain.getDevice("mainEngine_RL").motorDirection = 1
		powertrain.getDevice("mainEngine_FR").motorDirection = 1
		powertrain.getDevice("mainEngine_RR").motorDirection = -1

				electrics.values.throttle_RR =  electrics.values.throttle*0.9
				electrics.values.throttle_FR =  electrics.values.throttle
				electrics.values.throttle_RL = electrics.values.throttle*0.9
				electrics.values.throttle_FL = electrics.values.throttle

	elseif electrics.values.steering_input < -0.05 then
		powertrain.getDevice("mainEngine_FL").motorDirection = 1
		powertrain.getDevice("mainEngine_RL").motorDirection = -1
		powertrain.getDevice("mainEngine_FR").motorDirection = -1
		powertrain.getDevice("mainEngine_RR").motorDirection = 1

				electrics.values.throttle_RR =  electrics.values.throttle*0.9
				electrics.values.throttle_FR =  electrics.values.throttle
				electrics.values.throttle_RL = electrics.values.throttle*0.9
				electrics.values.throttle_FL = electrics.values.throttle

	else 
		powertrain.getDevice("mainEngine_FL").motorDirection = 0
		powertrain.getDevice("mainEngine_RL").motorDirection = 0
		powertrain.getDevice("mainEngine_FR").motorDirection = 0	
		powertrain.getDevice("mainEngine_RR").motorDirection = 0	
	end 
else
  


	electrics.values.throttle_FR =  electrics.values.throttle
	electrics.values.throttle_RR =  electrics.values.throttle
	electrics.values.throttle_FL = electrics.values.throttle
	electrics.values.throttle_RL = electrics.values.throttle

	electrics.values.steering_input_drive=electrics.values.steering_input
  
 end  
  
  


  



 
end

local function init(jbeamData)

  electrics.values.brake_combined = 0
  
  electrics.values.throttle_FL = 0
  electrics.values.throttle_RL = 0
  electrics.values.throttle_FR = 0
  electrics.values.throttle_RR = 0
  electrics.values.steering_input_drive = 0	


--  electrics.values.span = 0
--  electrics.values.span_updown_change = 0  

end

M.init = init
M.updateGFX = updateGFX
M.update = update

return M